unit UnidadMenuPrincipal;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ScktComp, Buttons, Menus, ExtCtrls, ComCtrls, shellapi, inifiles;

type
  TformMenuPrincipal = class(TForm)
    WSsocket: TClientSocket;
    dlGuardar: TSaveDialog;
    PopupMenu1: TPopupMenu;
    Savetofile1: TMenuItem;
    Panel1: TPanel;
    lblOpenPorts: TLabel;
    Splitter1: TSplitter;
    GroupBox1: TGroupBox;
    GroupBox2: TGroupBox;
    txtPuertoInicio: TEdit;
    lblPorttoport: TLabel;
    Label1: TLabel;
    txtPuertoFin: TEdit;
    Panel2: TPanel;
    lInfo: TLabel;
    Label3: TLabel;
    Panel3: TPanel;
    bIniciar: TButton;
    bDetener: TButton;
    bCerrar: TButton;
    bGuardar: TButton;
    LWEB: TLabel;
    ProgressBar1: TProgressBar;
    txtIP: TComboBox;
    bSeleccionPuertoI: TButton;
    bSeleccionPuertoF: TButton;
    tab: TPageControl;
    tabAbiertos: TTabSheet;
    tabTodos: TTabSheet;
    lsTodosPuertos: TListBox;
    lsAbiertos: TListBox;
    procedure bIniciarClick(Sender: TObject);
    procedure WSsocketConnect(Sender: TObject; Socket: TCustomWinSocket);
    procedure WSsocketError(Sender: TObject; Socket: TCustomWinSocket;
      ErrorEvent: TErrorEvent; var ErrorCode: Integer);
    procedure bDetenerClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure bCerrarClick(Sender: TObject);
    procedure bGuardarClick(Sender: TObject);
    procedure LWEBClick2(Sender: TObject);
    procedure bSeleccionPuertoIClick(Sender: TObject);
    procedure bSeleccionPuertoFClick(Sender: TObject);
    procedure Savetofile1Click(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  formMenuPrincipal: TformMenuPrincipal;
  PuertoInicial : integer;
  intError: integer;
  PuertoFinal : integer;
  iniciado : boolean;
  numPuertosAbiertos : integer;
implementation

uses UnidadPuertos;


{$R *.dfm}

//Lee una cadena de texto de un INI
function leCadINI (clave, cadena : string; defecto : string) : string;
begin
  with tinifile.create (changefileext(paramstr(0),'.INI')) do
  try
    result := readString (clave, cadena, defecto);
  finally
    free;
  end;
end;

//escribe una cadena de texto en un INI
procedure esCadINI (clave, cadena, valor : string);
begin
  with tinifile.create (changefileext(paramstr(0),'.INI')) do
  try
    writeString (clave, cadena, valor);
  finally
    free;
  end;
end;

function encontrarAplicacion (puerto : string) : string;
var
  fichero : string;
  lista : TStringList;
  i : integer;
  aplicacionOb, puertoOb : string;
begin
  Result := '';
  fichero := ExtractFilePath (ParamStr(0)) + 'puertos.txt';
  lista := TStringList.Create;
  if FileExists(fichero) then
    lista.LoadFromFile(fichero);
  for i := 0 to lista.count - 1 do
  begin
    puertoOB := copy (lista.Strings[i], pos ('=', lista.Strings[i]) + 1,
        length (lista.Strings[i])); 
    if puerto = puertoOb then
    begin
      aplicacionOb := copy (lista.Strings[i], 1, pos ('=', lista.Strings[i]) - 1);;
      Result := aplicacionOb;
      Break;
    end;
  end;
end;

procedure guardarIP (ip : string);
var
  lista : TStringList;
  fichero : string;
  i : integer;
  existe : boolean;
begin
  fichero := ExtractFilePath(ParamStr(0)) + 'ips.txt';
  lista := TStringList.Create;
  if FileExists(fichero) then
    lista.LoadFromFile(fichero);
  existe := false;
  for i := 0 to lista.Count - 1 do
  begin
    if lista.Strings[i] = ip then
    begin
      existe := true;
      break;
    end;
  end;
  if not existe then
    lista.Add(ip);
  lista.SaveToFile(fichero);
end;

procedure TformMenuPrincipal.bIniciarClick(Sender: TObject);
var
  continuar : boolean;
begin
  if txtIP.Text <> '' then
  begin
    numPuertosAbiertos := 0;
    lInfo.Caption := '';
    lInfo.Refresh;
    if StrToInt(txtPuertoFin.Text) < StrToInt(txtPuertoInicio.Text) then
    begin
      MessageDlg('El puerto de inicio debe ser mayor o igual que el ' +
          'puerto de fin de escaneo.', mtWarning, [mbok], 0);
      txtPuertoInicio.SetFocus;
    end
    else
    begin
      continuar := true;
      if StrToInt(txtPuertoFin.Text) - StrToInt(txtPuertoInicio.Text) > 3000 then
        continuar := MessageDlg('Ha seleccionado el escaneo de ms de ' +
            '3000 puertos si contina con el proceso puede ser muy lento ' +
            'desea continuar?', mtConfirmation, [mbyes, mbno], 0) = mryes;
      if continuar then
      begin
        ProgressBar1.Max := strtoint(txtPuertoFin.Text);
        ProgressBar1.Min := strtoint(txtPuertoInicio.Text);
        ProgressBar1.Position :=  StrToInt(txtPuertoInicio.Text);
        ProgressBar1.Refresh;
        guardarIP (txtIP.Text);
        lsTodosPuertos.Items.Clear;
        lsAbiertos.Items.Clear;
        wsSocket.Address := txtIP.text;
        PuertoInicial := strtoint(txtPuertoInicio.text);
        PuertoFinal := strtoint(txtPuertoFin.text);
        wsSocket.Port := PuertoInicial;
        wsSocket.Active := true;
        bIniciar.Enabled := false;
        bDetener.Enabled := true;
        bIniciar.Default := not bIniciar.Default;
        bDetener.Default := not bDetener.Default;
        lsTodosPuertos.Items.Add(datetostr(date) + ' - ' + timetostr(time) +
            ' -> Iniciado escaneo (' + txtIP.text + ')');
        lsTodosPuertos.Items.Add(datetostr(date) + ' - ' + timetostr(time) +
            ' -> Desde puerto ' + txtPuertoInicio.text + ' hasta puerto ' +
            txtPuertoFin.Text);
        iniciado := True;
      end;
    end;
  end
  else
  begin
    MessageDlg('Debe especificar la IP o nombre de red del PC a escanear.',
        mtWarning, [mbok], 0);
    txtIP.SetFocus;
  end;
end;

procedure TformMenuPrincipal.WSsocketConnect(Sender: TObject; Socket: TCustomWinSocket);
  label done;
var
  aplicacion : string;
begin
  ProgressBar1.Position := PuertoInicial;
  ProgressBar1.Refresh;
  lsTodosPuertos.Items.Add(datetostr(date) + ' - ' + timetostr(time) +
      ' -> Puerto: ' + inttostr(PuertoInicial) +
      ' -> *****  Est ABIERTO  *****');
  aplicacion := encontrarAplicacion(inttostr(PuertoInicial));
  if aplicacion <> '' then
    lsAbiertos.Items.Add(datetostr(date) + ' - ' + timetostr(time) +
        ' -> Puerto: ' + inttostr(PuertoInicial) + ' -> ' + aplicacion)
  else
    lsAbiertos.Items.Add(datetostr(date) + ' - ' + timetostr(time) +
      ' -> Puerto: ' + inttostr(PuertoInicial));
  numPuertosAbiertos := numPuertosAbiertos + 1;
  lInfo.Caption := 'Puertos abiertos: ' + IntToStr(numPuertosAbiertos);
  lInfo.Refresh;
  wsSocket.Active := false;
  PuertoInicial := PuertoInicial + 1;
  wsSocket.Port := PuertoInicial;
  if iniciado = false then
    exit;
  if PuertoInicial > PuertoFinal then
    goto done
  else
  begin
    wsSocket.Address := txtIP.Text;
    wsSocket.Active := true;
    exit;
  end;

done:
  lsTodosPuertos.Items.Add(datetostr(date) + ' - ' + timetostr(time) +
      ' -> Escaneo finalizado (' + txtIP.text + ')');
  iniciado := False;
  bDetener.Enabled := false;
  bIniciar.enabled := true;
end;

procedure TformMenuPrincipal.WSsocketError(Sender: TObject; Socket: TCustomWinSocket;
    ErrorEvent: TErrorEvent; var ErrorCode: Integer);
  label done;
begin
  ProgressBar1.Position := PuertoInicial;
  ProgressBar1.Refresh;
  errorcode := 0;
  lsTodosPuertos.Items.Add(datetostr(date) + ' - ' + timetostr(time) +
      ' -> Puerto: ' + inttostr(PuertoInicial) + ' -> est cerrado.');
  wsSocket.Active := false;
  PuertoInicial := PuertoInicial + 1;
  wsSocket.Port := PuertoInicial;
  if iniciado = false then
    exit;
  if PuertoInicial > PuertoFinal then
    goto done
  else
  begin
    wsSocket.Address := txtIP.Text;
    wsSocket.Active := true;
    exit;
  end;
done:
  lsTodosPuertos.Items.Add(datetostr(date) + ' - ' + timetostr(time) +
      ' -> Escaneo finalizado (' + txtIP.text + ')');
  lsTodosPuertos.Items.Add(datetostr(date) + ' - ' + timetostr(time) +
      ' -> Nmero de puertos abiertos: ' + IntToStr(numPuertosAbiertos));
  lsTodosPuertos.Items.Add(datetostr(date) + ' - ' + timetostr(time) +
      ' -> Por www.ajpdsoft.com (AjpdSoft)');
  iniciado := false;
  bDetener.Enabled := false;
  bIniciar.enabled := true;
end;

procedure TformMenuPrincipal.bDetenerClick(Sender: TObject);
begin
  iniciado := false;
  bIniciar.Enabled := true;
  bDetener.Enabled := false;
  wssocket.Active := false;
  lsTodosPuertos.Items.Add(datetostr(date) + ' - ' + timetostr(time) +
      ' -> Escaneo detenido en el puerto: ' +
      inttostr(PuertoInicial));
  bIniciar.Default := not bIniciar.Default;
  bDetener.Default := not bDetener.Default;
end;

procedure TformMenuPrincipal.FormCreate(Sender: TObject);
var
  fichero : string;
begin
  iniciado := false;
  fichero := ExtractFilePath(ParamStr(0)) + 'ips.txt';
  if FileExists(fichero) then
    txtIP.Items.LoadFromFile(fichero);
  txtIP.Text := leCadINI ('ltimos valores', 'IP', '127.0.0.1');
  txtPuertoInicio.Text := leCadINI ('ltimos valores', 'Puerto inicio', '1');
  txtPuertoFin.Text := leCadINI ('ltimos valores', 'Puerto fin', '200');
end;

procedure TformMenuPrincipal.bCerrarClick(Sender: TObject);
begin
  Close;
end;

procedure TformMenuPrincipal.bGuardarClick(Sender: TObject);
begin
  if dlGuardar.Execute then
  begin
    if tabTodos.Showing then
      lsTodosPuertos.Items.SaveToFile (dlGuardar.filename)
    else
      lsAbiertos.Items.SaveToFile (dlGuardar.filename);
  end;
end;

procedure TformMenuPrincipal.LWEBClick2(Sender: TObject);
begin
  ShellExecute(Handle, Nil, PChar(LWEB.CAPTION),
      Nil, Nil, SW_SHOWNORMAL);
end;

procedure TformMenuPrincipal.bSeleccionPuertoIClick(Sender: TObject);
var
  formulario : TformPuertos;
begin
  formulario := TformPuertos.Create(Application);
  formulario.Tag := 10;
  try
    formulario.ShowModal;
  finally
    formulario.Free;
  end;
end;

procedure TformMenuPrincipal.bSeleccionPuertoFClick(Sender: TObject);
var
  formulario : TformPuertos;
begin
  formulario := TformPuertos.Create(Application);
  formulario.Tag := 20;
  try
    formulario.ShowModal;
  finally
    formulario.Free;
  end;
end;

procedure TformMenuPrincipal.Savetofile1Click(Sender: TObject);
begin
  bGuardarClick (Self);
end;

procedure TformMenuPrincipal.FormClose(Sender: TObject;
  var Action: TCloseAction);
begin
  esCadINI ('ltimos valores', 'IP', txtIP.Text);
  esCadINI ('ltimos valores', 'Puerto inicio', txtPuertoInicio.Text);
  esCadINI ('ltimos valores', 'Puerto fin', txtPuertoFin.Text);
end;

end.
